%% rOEF Calculation called by main function RUN_mqBOLD_auto.m
%
%   - Copyright by PD Dr. Christine Preibisch (CHP) <preibisch@tum.de>
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Expected data structure (is generated by run2_sortData)
%--------------------------------------------------------------------------
%   + '/output'
%       + '/sub-p001'       : subjects need to be numbered
%             +  /qBOLD'    : contains previous structure
%               + '/T1w/'   : contains (segmented) T1w data
%               + '/FLAIR/' : contains (segmented) FLAIR data        
%               + '/DSC'    : folder for CBV processing
%                  + '/Perfusion :  contains DSC data
%                  + FLAIR & T1w copied from top level folder
%                                for coregistration to DAS data
%                  + folders containing processed parameter maps 
%               + '/T2'     : contains T2 data & processings if
%                             only one data set is available
%               + '/conditionDir_1'   : condition subfolders can be
%               + '/conditionDir_...' : named arbitrarly via setting
%               + '/conditionDir_n'%  : the variable (see below): 
%                 -> conditions = ["rest","control","calc", "mem"];
%                 -> will then contain folders T2 (if condition
%                    specific), T2S, pCASL & processings
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Modifications:
%
% Version 1.1, 2011-01-24, N.Hirsch
%   changed VASO selection mode to manual
% Version 1.2, 2011-02-03, N.Hirsch
%   improved T mapping, changed VASO sorting to automatic according to PAR
%   files, grad maps are smoothed
% Version 1.3, 2011-03-07, N.Hirsch
%   updated Y calculation, updated R2' calculation
% Version 1.4, 2011-03-20, C. Preibisch
%   added HI calculation, updated R2' calculation
% Version 1.5, 2011-04-08, C. Preibisch
%   adapted to new protocol, including anatomy data (FLAIR, MPR, T2w_FFE)
% Version 1.6.1 & 1.6.2, 2011-06-30, N. Hirsch, C. Preibisch
%   cleanups, updated fillholes.m,
%   updated inhomogeneity correction factor calculation,
%   option for VASO CBV calculation corrected for extravasation,
%   option for CBV normalization, improved masking (based on R2')
%
% Version 2.0.1 2011-07-13, N. Hirsch
%   eliminated calcR2R2S, updated christine_imagefit2param_gradient.m,
%   manual mask selection in calc_HI.m, option to read DSC CBV,
%   clean up VASO directory before reading files, delete unnecessary files,
%   flexible starting points
% Version 2.0.3 2011-08-02, N. Hirsch
%   updated calc_vaso_oxy.m, included k space motion correction with half
%   resolution T2* data set
% Version 2.0.5 2011-08-10, N. Hirsch
%   minor corrections
% Version 2.1 2011-10-18, N. Hirsch
%   optimized VASO calculation (smoothing, normalization)
%   automatic selection of half resolution file for motion correction
%   new script correct_vaso_CBVpreps
% Version 2.1.1 2011-11-11. C. Preibisch
%   Omit HI-calculation
%   Minor corrections in data input in correct_vaso_CBVpreps
%
% Version 3.0 2012-03-16 N. Hirsch
%   VASO replaced by DCE
% Version 3.1 2012-03-27 N. Hirsch
%   automated data selection
%   motion correction: phase information (for gradient calculation) is not
%   put together from both T2* data sets anymore, but taken from fr data
%   only (motion corrected phase images were very close to 0 and gradients
%   very small -> gradient correction had almost no effect when moco was
%   used)
% Version 3.4 2012-07-25 C. Preibisch
%   Improved recalculation of T2* maps (all options available)
%   Enable later coregistration of (improved) DCE map + hypoxia calculation
% Version 3.4.1 2012-08-13 N. Hirsch
%   Coregistration of CBV_DCE via T1 map
% version batch_oxy_stroke2.0 C. Preibisch
%   Adaptation to stroke protocol
% 10.1.2013: Introduce some minor changes: quot -> rOEF ; write masked MTT and CBF
%
% 2015 CHP & Stephan Kaczmarz (SK): cleaned up code for PAR/REC processing
%   - SKJUL16:
%       + Change from analyze to nifty format
%       + Introduce option for predefined option selection
%       + Adding comments
%
% JUL 2017 CP: Major clean up & Better integration of Dicom
% JUN 2018 CP: Adaptation to Valentins qBOLD experiments
%              Facilitate processing without DSC data
% JAN 2019 CP: - repair & adapt processing of Dicom data from MRPET
%              - full adaptation to allow multiple condition mqBOLD
%              - further cleanup 
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% MAR/APR 2020: major revision & cleanup: adaption to nifti data from BIDS
%               (i.e. removal of all dedicated data conversion 
%               from PAR/REC or DICOM)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% All input data are expected as nifti from BIDS
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Needs to account for implementation specific pecularities of Siemens
% and Philips data
% CAVEAT: Original implementation (t2smap_NH by Nuria Hirsch) is valid for 
% slice thickness of 3 mm (@Philips Achieva and Siemens mMR Biograph)
% CAVEAT: Besides RF-Pulseshape, the absolute strength of Slice selection 
% gradient is important for correction of background gradients.
% Needs to be adapted in case of sequence modifications.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% CP 15JUN18 - T2* map calculation employs ralf_t2s_toolbox_24jan18
% CP MAR/APR 2020 - major revision of  data input and T2* calculation
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [SubjectDir, filelist] = run4_mqBOLD_rOEF(SubjectDir, filelist, ...
                      subject_name, conditions, nconditions, T2s_pars, flag)  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% SubjectDir:  Structure containing all relevant folders
% filelist:    Structure containing all relevant path to required data
%              --> SubjectDir and filelist are set in functions called by
%                  RUN_mqBOLD_auto:
%                       - run1_process_anatomy
%                       - run2_sortData
%                       - run3_dsc_cbv
% T2s_pars: Contains important information on temporal shape  and duration 
%           of excitation RF pulse (optimal choice: EXPO; otherwise: SINC, 
%           SG) and slice selection gradient strength in T2*-mapping
%           ---> important for correction of magnetic background gradients
%           ---> defined in 'T2s_settings()'
% nconditions: number of  conditions during which T2* mapping was performed
%           - this version assumes a single T2 map, which is used for all 
%             conditions to derive R2' for rOEF (OK because T2 is not
%             expected to vary a lot across conditions. This was also 
%             verified in pilot experiments.)
%           - CBV maps can be eihter condition specific (for 2 conditions)
%             or used for multiple conditions due to constraints in
%             contrast agent applications
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

fprintf('\nrun4_mqBOLD_rOEF (multiple conditions, w/o single/multiple DSC)\n');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Calculate & Coregister & Copy T2 parameter maps for multiple conditions
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if T2s_pars.T2_nconditions == 1
    %----------------------------------------------------------------------
    % One T2 multi-echo data set in toplevel qBOLD directory that is used  
    % as target for coregistration and R2' calculation
    %----------------------------------------------------------------------
    fprintf('\nCalculate T2 parameter map for subject %s\n', subject_name);
    filelist = calc_T2_map(SubjectDir, filelist, subject_name, nconditions, ...
                                                            T2s_pars, flag);
% elseif T2s_pars.T2_nconditions > 1
%     %----------------------------------------------------------------------
%     % one T2 multi-echo data in in EACH condition directory
%     %---------------------------------------------------------------------- 
%     for ncd = 1:nconditions
%         % calculate parameter map for each condition
%         % CAVE: not tested for multiple T2 maps!!!
%         filelist.condition(ncd) = calc_T2_map(SubjectDir.condition(ncd), ...
%                         filelist.condition(ncd), subject_name, nconditions, ...
%                                                           T2s_pars, flag);                  
%     end
%     %----------------------------------------------------------------------
%     % coregister all T2 maps for different conditions to TE1 of condition 1
%     %----------------------------------------------------------------------
% 	coreg_allConditionsT2(SubjectDir, subject_name, conditions, nconditions);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Calculate & Coregistering T2*: Target: TE1 of T2 (single or 1st condition) 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%--------------------------------------------------------------------------
% calculate T2* parameter maps for each condition
% NOTE: assumes one T2* multi-echo data set in each condition directory
%--------------------------------------------------------------------------
fprintf('\nCalculate T2* parameter maps for subject %s\n', subject_name);
filelist = calc_T2star_maps(SubjectDir, filelist, subject_name, ...
                                            nconditions, T2s_pars, flag);
%--------------------------------------------------------------------------
% Coregister T2* parameter maps for each condition to TE1 of reference T2
% NOTE: assumes one T2* multi-echo data set in each condition directory
%--------------------------------------------------------------------------
fprintf('\nCoregistering T2* parameter maps to TE1 of T2 for subject %s\n',...
    subject_name);
filelist = coreg_T2s_to_TE1T2(SubjectDir, filelist, subject_name,...
                                           	nconditions, T2s_pars, flag);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Coregistering DSC-base nCBV: Target: TE1 of T2 (single or first condition) 
% CAVE: consider single or multiple DSC!!!
% NOTE: coregistered T1w & FLAIR data & segments are used as source and PO
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
fprintf('\nCoregistering CBV parameter maps to TE1 of T2 for subject %s\n',...
                                                             subject_name);
filelist = coreg_nCBV_to_TE1T2(SubjectDir, filelist, subject_name,  ...
                               conditions, nconditions, T2s_pars, flag);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% calculating R2, R2*, R2', MR-rOEF
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
fprintf('\nCalculating rOEF parameter maps for subject %s\n',subject_name);
filelist = calc_rOEF(SubjectDir, filelist, subject_name, nconditions,  ...
                                           T2s_pars, flag);
end
